TelepathyQt4: ConnectionInterfaceAvatarsInterface Class Reference

| Home · All Classes · All Namespaces · Modules · Functions · Files

# ConnectionInterfaceAvatarsInterface Class Reference
[Connection proxies]

`#include <TelepathyQt4/Connection>`

Inherits Tp::AbstractInterface.

List of all members.

## Public Slots

- QDBusPendingReply< QStringList,
  ushort, ushort, ushort, ushort,
  uint > GetAvatarRequirements ()
- QDBusPendingReply< QStringList > GetAvatarTokens (const Tp::UIntList &contacts)
- QDBusPendingReply
  < Tp::AvatarTokenMap > GetKnownAvatarTokens (const Tp::UIntList &contacts)
- QDBusPendingReply< QByteArray,
  QString > RequestAvatar (uint contact)
- QDBusPendingReply RequestAvatars (const Tp::UIntList &contacts)
- QDBusPendingReply< QString > SetAvatar (const QByteArray &avatar, const QString &MIMEType)
- QDBusPendingReply ClearAvatar ()

## Signals

- void AvatarUpdated (uint contact, const QString &newAvatarToken)
- void AvatarRetrieved (uint contact, const QString &token, const QByteArray &avatar, const QString &type)

## Public Member Functions

- ConnectionInterfaceAvatarsInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
- ConnectionInterfaceAvatarsInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
- ConnectionInterfaceAvatarsInterface (Tp::DBusProxy *proxy)
- ConnectionInterfaceAvatarsInterface (const Tp::Client::ConnectionInterface &mainInterface)
- ConnectionInterfaceAvatarsInterface (const Tp::Client::ConnectionInterface &mainInterface, QObject *parent)
- QStringList SupportedAvatarMIMETypes () const TELEPATHY_GNUC_DEPRECATED
- uint MinimumAvatarHeight () const TELEPATHY_GNUC_DEPRECATED
- uint MinimumAvatarWidth () const TELEPATHY_GNUC_DEPRECATED
- uint RecommendedAvatarHeight () const TELEPATHY_GNUC_DEPRECATED
- uint RecommendedAvatarWidth () const TELEPATHY_GNUC_DEPRECATED
- uint MaximumAvatarHeight () const TELEPATHY_GNUC_DEPRECATED
- uint MaximumAvatarWidth () const TELEPATHY_GNUC_DEPRECATED
- uint MaximumAvatarBytes () const TELEPATHY_GNUC_DEPRECATED

## Static Public Member Functions

- static const char * staticInterfaceName ()

## Protected Member Functions

- virtual void invalidate (Tp::DBusProxy *, const QString &, const QString &)

## Properties

- QStringList SupportedAvatarMIMETypes
- uint MinimumAvatarHeight
- uint MinimumAvatarWidth
- uint RecommendedAvatarHeight
- uint RecommendedAvatarWidth
- uint MaximumAvatarHeight
- uint MaximumAvatarWidth
- uint MaximumAvatarBytes

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Connection.Interface.Avatars."

## Constructor & Destructor Documentation

ConnectionInterfaceAvatarsInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0` |
| ) |  |  |

Creates a ConnectionInterfaceAvatarsInterface associated with the given object on the session bus.

Parameters:

  | busName | Name of the service the object is on.
  | objectPath | Path to the object on the service.
  | parent | Passed to the parent class constructor.

ConnectionInterfaceAvatarsInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0` |
| ) |  |  |

Creates a ConnectionInterfaceAvatarsInterface associated with the given object on the given bus.

Parameters:

  | connection | The bus via which the object can be reached.
  | busName | Name of the service the object is on.
  | objectPath | Path to the object on the service.
  | parent | Passed to the parent class constructor.

ConnectionInterfaceAvatarsInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ConnectionInterfaceAvatarsInterface associated with the same object as the given proxy.

Parameters:

  | proxy | The proxy to use. It will also be the QObject::parent() for this object.

ConnectionInterfaceAvatarsInterface | ( | const Tp::Client::ConnectionInterface & | mainInterface | ) | `[explicit]`

Creates a ConnectionInterfaceAvatarsInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters:

  | mainInterface | The proxy to use.

ConnectionInterfaceAvatarsInterface | ( | const Tp::Client::ConnectionInterface & | mainInterface,
|  | QObject * | parent |
| ) |  |  |

Creates a ConnectionInterfaceAvatarsInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters:

  | mainInterface | The proxy to use.
  | parent | Passed to the parent class constructor.

## Member Function Documentation

static const char* staticInterfaceName | ( |  | ) | `[inline, static]`

Returns the name of the interface "org.freedesktop.Telepathy.Connection.Interface.Avatars", which this class represents.

Returns:
  The D-Bus interface name.

QStringList SupportedAvatarMIMETypes | ( |  | ) | const`[inline]`

Getter for the remote object property "SupportedAvatarMIMETypes".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

uint MinimumAvatarHeight | ( |  | ) | const`[inline]`

Getter for the remote object property "MinimumAvatarHeight".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

uint MinimumAvatarWidth | ( |  | ) | const`[inline]`

Getter for the remote object property "MinimumAvatarWidth".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

uint RecommendedAvatarHeight | ( |  | ) | const`[inline]`

Getter for the remote object property "RecommendedAvatarHeight".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

uint RecommendedAvatarWidth | ( |  | ) | const`[inline]`

Getter for the remote object property "RecommendedAvatarWidth".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

uint MaximumAvatarHeight | ( |  | ) | const`[inline]`

Getter for the remote object property "MaximumAvatarHeight".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

uint MaximumAvatarWidth | ( |  | ) | const`[inline]`

Getter for the remote object property "MaximumAvatarWidth".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

uint MaximumAvatarBytes | ( |  | ) | const`[inline]`

Getter for the remote object property "MaximumAvatarBytes".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

QDBusPendingReply<QStringList, ushort, ushort, ushort, ushort, uint> GetAvatarRequirements | ( |  | ) | `[inline, slot]`

Begins a call to the D-Bus method "GetAvatarRequirements" on the remote object.

Get the required format of avatars on this connection.

Returns:

An array of supported MIME types (eg image/jpeg)

Returns:

The minimum image width in pixels

Returns:

The minimum image height in pixels

Returns:

The maximum image width in pixels, or 0 if there is no limit

Returns:

The maximum image height in pixels, or 0 if there is no limit

Returns:

The maximum image size in bytes, or 0 if there is no limit

QDBusPendingReply<QStringList> GetAvatarTokens | ( | const Tp::UIntList & | contacts | ) | `[inline, slot]`

Begins a call to the D-Bus method "GetAvatarTokens" on the remote object.

Get the unique tokens for all of the given contacts' avatars. Using this method in new Telepathy clients is deprecated; use GetKnownAvatarTokens instead.

Parameters:

  | contacts | An array of handles representing contacts

Returns:

An array of avatar tokens or empty strings (if no avatar is set) in the same order as the given array of contact handles

QDBusPendingReply<Tp::AvatarTokenMap> GetKnownAvatarTokens | ( | const Tp::UIntList & | contacts | ) | `[inline, slot]`

Begins a call to the D-Bus method "GetKnownAvatarTokens" on the remote object.

Get the unique tokens for the given contacts' avatars. These tokens can be persisted across connections, and should be used by the client to check whether the avatars have been updated. For handles other than the self handle, only tokens that are already known are returned; an empty token means the given contact has no avatar. However, a CM must always have the tokens for the self handle if one is set (even if it is set to no avatar). On protocols where the avatar does not persist between connections, a CM should omit the self handle from the returned map until an avatar is explicitly set or cleared.

Parameters:

  | contacts | An array of handles representing contacts

Returns:

A dictionary of handles mapped to avatar tokens, containing only the known avatar tokens.

QDBusPendingReply<QByteArray, QString> RequestAvatar | ( | uint | contact | ) | `[inline, slot]`

Begins a call to the D-Bus method "RequestAvatar" on the remote object.

Request the avatar for a given contact. Using this method in new Telepathy clients is deprecated; use RequestAvatars instead.

Parameters:

  | contact | An integer handle for the contact to request the avatar for

Returns:

An array of bytes containing the image data

Returns:

A string containing the image MIME type (eg image/jpeg), or empty if unknown

QDBusPendingReply RequestAvatars | ( | const Tp::UIntList & | contacts | ) | `[inline, slot]`

Begins a call to the D-Bus method "RequestAvatars" on the remote object.

Request avatars for a number of contacts. The AvatarRetrieved signal is emitted for each avatar retrieved. If the handles are valid but retrieving an avatar fails (for any reason, including the contact not having an avatar) the AvatarRetrieved signal is not emitted for that contact.

Parameters:

  | contacts | The contacts to retrieve avatars for

QDBusPendingReply<QString> SetAvatar | ( | const QByteArray & | avatar,
|  | const QString & | MIMEType |
| ) |  |  | `[inline, slot]`

Begins a call to the D-Bus method "SetAvatar" on the remote object.

Set a new avatar image for this connection. The avatar image must respect the requirements obtained by GetAvatarRequirements.

Parameters:

  | avatar | An array of bytes representing the avatar image data
  | MIMEType | A string representing the image MIME type

Returns:

The string token of the new avatar

QDBusPendingReply ClearAvatar | ( |  | ) | `[inline, slot]`

Begins a call to the D-Bus method "ClearAvatar" on the remote object.

Remove the avatar image for this connection.

void AvatarUpdated | ( | uint | contact,
|  | const QString & | newAvatarToken |
| ) |  |  | `[signal]`

Represents the signal "AvatarUpdated" on the remote object.

Emitted when the avatar for a contact has been updated, or first discovered on this connection. If the token differs from the token associated with the client's cached avatar for this contact, the new avatar should be requested with RequestAvatars.

Parameters:

  | contact | An integer handle for the contact whose avatar has changed
  | newAvatarToken | Unique token for their new avatar

void AvatarRetrieved | ( | uint | contact,
|  | const QString & | token,
|  | const QByteArray & | avatar,
|  | const QString & | type |
| ) |  |  | `[signal]`

Represents the signal "AvatarRetrieved" on the remote object.

Emitted when the avatar for a contact has been retrieved.

Parameters:

  | contact | The contact whose avatar has been retrieved
  | token | The token corresponding to the avatar
  | avatar | An array of bytes containing the image data
  | type | A string containing the image MIME type (eg image/jpeg), or empty if unknown

virtual void invalidate | ( | Tp::DBusProxy * | ,
|  | const QString & | ,
|  | const QString & |  |
| ) |  |  | `[protected, virtual]`

## Property Documentation

QStringList SupportedAvatarMIMETypes`[read]`

Represents property "SupportedAvatarMIMETypes" on the remote object.

An array of supported MIME types (e.g. "image/jpeg"). Clients MAY assume that the first type in this array is preferred. This property cannot change after the Connection goes to the Connected state.

uint MinimumAvatarHeight`[read]`

Represents property "MinimumAvatarHeight" on the remote object.

The minimum height in pixels of an avatar on this protocol, which MAY be 0. This property cannot change after the Connection goes to the Connected state.

uint MinimumAvatarWidth`[read]`

Represents property "MinimumAvatarWidth" on the remote object.

The minimum width in pixels of an avatar on this protocol, which MAY be 0. This property cannot change after the Connection goes to the Connected state.

uint RecommendedAvatarHeight`[read]`

Represents property "RecommendedAvatarHeight" on the remote object.

The recommended height in pixels of an avatar on this protocol, or 0 if there is no preferred height. This property cannot change after the Connection goes to the Connected state. In XMPP a recommended width is given by the protocol specification; in proprietary protocols, using the same avatar size as the proprietary client is likely to lead to the best display to other users.

uint RecommendedAvatarWidth`[read]`

Represents property "RecommendedAvatarWidth" on the remote object.

The recommended width in pixels of an avatar on this protocol, or 0 if there is no preferred width. This property cannot change after the Connection goes to the Connected state. The rationale is the same as for RecommendedAvatarHeight.

uint MaximumAvatarHeight`[read]`

Represents property "MaximumAvatarHeight" on the remote object.

The maximum height in pixels of an avatar on this protocol, or 0 if there is no limit. This property cannot change after the Connection goes to the Connected state.

uint MaximumAvatarWidth`[read]`

Represents property "MaximumAvatarWidth" on the remote object.

The maximum width in pixels of an avatar on this protocol, or 0 if there is no limit. This property cannot change after the Connection goes to the Connected state.

uint MaximumAvatarBytes`[read]`

Represents property "MaximumAvatarBytes" on the remote object.

The maximum size in bytes of an avatar on this protocol, or 0 if there is no limit. This property cannot change after the Connection goes to the Connected state.